
package net.mcreator.jojo_mod.item;

import net.minecraftforge.registries.ObjectHolder;

import net.minecraft.item.crafting.Ingredient;
import net.minecraft.item.SwordItem;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.Item;
import net.minecraft.item.IItemTier;
import net.minecraft.block.Blocks;

import net.mcreator.jojo_mod.JoJoModElements;

@JoJoModElements.ModElement.Tag
public class SilverChariotsBladeItem extends JoJoModElements.ModElement {
	@ObjectHolder("jojo_mod:silverchariotsblade")
	public static final Item block = null;
	public SilverChariotsBladeItem(JoJoModElements instance) {
		super(instance, 59);
	}

	@Override
	public void initElements() {
		elements.items.add(() -> new SwordItem(new IItemTier() {
			public int getMaxUses() {
				return 1000;
			}

			public float getEfficiency() {
				return 4f;
			}

			public float getAttackDamage() {
				return 4f;
			}

			public int getHarvestLevel() {
				return 1;
			}

			public int getEnchantability() {
				return 5;
			}

			public Ingredient getRepairMaterial() {
				return Ingredient.fromStacks(new ItemStack(Blocks.IRON_BLOCK, (int) (1)));
			}
		}, 3, -1.8f, new Item.Properties().group(ItemGroup.TOOLS)) {
		}.setRegistryName("silverchariotsblade"));
	}
}
